---
apiVersion: v1
kind: ConfigMap
metadata:
  labels:
    app: rest-villains
    application: villains-service
    system: quarkus-super-heroes
  name: rest-villains-config
data:
  quarkus.hibernate-orm.database.generation: validate
  quarkus.hibernate-orm.sql-load-script: no-file
  quarkus.datasource.jdbc.url: jdbc:otel:postgresql://villains-db:5432/villains_database
  quarkus.opentelemetry.tracer.exporter.otlp.endpoint: http://otel-collector:4317
---
apiVersion: v1
kind: Secret
metadata:
  labels:
    app: rest-villains
    application: villains-service
    system: quarkus-super-heroes
  name: rest-villains-config-creds
data:
  quarkus.datasource.username: c3VwZXJiYWQ=
  quarkus.datasource.password: c3VwZXJiYWQ=
type: Opaque
---
apiVersion: v1
kind: Secret
metadata:
  labels:
    app: villains-db
    application: villains-service
    system: quarkus-super-heroes
  name: villains-db-config
data:
  POSTGRESQL_DATABASE: dmlsbGFpbnNfZGF0YWJhc2U=
  POSTGRESQL_USERNAME: c3VwZXJiYWQ=
  POSTGRESQL_PASSWORD: c3VwZXJiYWQ=
type: Opaque
---
apiVersion: v1
kind: ConfigMap
metadata:
  labels:
    app: villains-db
    application: villains-service
    system: quarkus-super-heroes
  name: villains-db-init
data:
  get-data.sh: |-
    #!/bin/bash

    curl https://raw.githubusercontent.com/quarkusio/quarkus-super-heroes/main/rest-villains/deploy/db-init/initialize-tables.sql --output /docker-entrypoint-initdb.d/1-init-tables.sql
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: villains-db
    application: villains-service
    system: quarkus-super-heroes
    app.kubernetes.io/part-of: villains-service
    app.openshift.io/runtime: postgresql
  name: villains-db
spec:
  replicas: 1
  selector:
    matchLabels:
      name: villains-db
  template:
    metadata:
      labels:
        application: villains-service
        name: villains-db
    spec:
      containers:
        - envFrom:
            - secretRef:
                name: villains-db-config
          image: bitnami/postgresql:14
          name: villains-db
          ports:
            - containerPort: 5432
          resources:
            limits:
              memory: 128Mi
            requests:
              memory: 32Mi
          volumeMounts:
            - mountPath: /bitnami/postgresql
              name: villains-db-data
            - mountPath: /docker-entrypoint-initdb.d
              name: villains-db-init-data
      initContainers:
        - command:
            - sh
            - get-data.sh
          image: registry.access.redhat.com/ubi8-minimal:8.6
          name: get-data
          volumeMounts:
            - mountPath: /docker-entrypoint-preinitdb.d
              name: villains-db-init
            - mountPath: /docker-entrypoint-initdb.d
              name: villains-db-init-data
          workingDir: /docker-entrypoint-preinitdb.d
      volumes:
        - emptyDir: {}
          name: villains-db-data
        - emptyDir: {}
          name: villains-db-init-data
        - configMap:
            name: villains-db-init
          name: villains-db-init
---
apiVersion: v1
kind: Service
metadata:
  labels:
    name: villains-db
    application: villains-service
    system: quarkus-super-heroes
  name: villains-db
spec:
  ports:
    - port: 5432
      protocol: TCP
      targetPort: 5432
  selector:
    name: villains-db
  type: ClusterIP
---
apiVersion: serving.knative.dev/v1
kind: Service
metadata:
  annotations:
    app.openshift.io/connects-to: "villains-db,otel-collector"
    app.openshift.io/vcs-ref: main
    app.openshift.io/vcs-url: https://github.com/quarkusio/quarkus-super-heroes
    app.quarkus.io/build-timestamp: 2022-11-14 - 19:52:48 +0000
    prometheus.io/scrape: "true"
    prometheus.io/path: /q/metrics
    prometheus.io/port: "8084"
    prometheus.io/scheme: http
  labels:
    app: rest-villains
    app.openshift.io/runtime: quarkus
    application: villains-service
    system: quarkus-super-heroes
    app.kubernetes.io/name: rest-villains
    app.kubernetes.io/part-of: villains-service
    app.kubernetes.io/version: java17-latest
  name: rest-villains
spec:
  template:
    spec:
      containers:
        - envFrom:
            - configMapRef:
                name: rest-villains-config
            - secretRef:
                name: rest-villains-config-creds
          image: quay.io/quarkus-super-heroes/rest-villains:java17-latest
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /q/health/live
              port: null
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          name: rest-villains
          ports:
            - containerPort: 8084
              name: http1
              protocol: TCP
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /q/health/ready
              port: null
              scheme: HTTP
            initialDelaySeconds: 0
            periodSeconds: 30
            successThreshold: 1
            timeoutSeconds: 10
          resources:
            limits:
              memory: 768Mi
            requests:
              memory: 256Mi
